#
# <20190501.1820.59>
#
# An attempt to really wait for idle...
#
proc waitForIdle {} {
  update idletasks
  update idletasks
}

proc realWaitForIdle {} {
  set this [incr ::waitForIdle::this]
  set ::waitForIdle::count($this) 0
  set progress {}
  set tmp [clock clicks]
  while {[incr failsafe] < 100} {
    after idle [list after 0 incr ::waitForIdle::count($this)]
    vwait ::waitForIdle::count($this)
    lappend progress [expr {[set now [clock clicks]] - $tmp} ]
    if {($now - $tmp) < $::waitForIdle::base} {break}
    set tmp $now
  }
  unset ::waitForIdle::count($this)
  return $progress

}

# A way more serious attempt...
namespace eval waitForIdle {
  variable wait 0
  variable count
  variable base 0
  variable tmp 0

  # Calibrate a wait clock
  # realWaitForIdle returns a list of all times (units of clicks)
  # that it took to find a time less than or equal to the "base"
  # It is limited to 100 tries by the failsafe.
  # Thus when we call it with base = 0 as it is now, we will get
  # 100 times. To set the base we take 4 times the minimum.
  set tmp 200000
  foreach ent [realWaitForIdle] {
    if {($ent * 4) < $tmp} {
      set tmp [expr $ent * 4]
    }
  }
  set base $tmp
}  
